A new merge stragety 'subtree'.
[git/git.git] / git-merge.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 USAGE='[-n] [--no-commit] [--squash] [-s <strategy>] [-m=<merge-message>] <commit>+'
7
8 SUBDIRECTORY_OK=Yes
9 . git-sh-setup
10 require_work_tree
11 cd_to_toplevel
12
13 test -z "$(git ls-files -u)" ||
14 die "You are in the middle of a conflicted merge."
15
16 LF='
17 '
18
19 all_strategies='recur recursive octopus resolve stupid ours subtree'
20 default_twohead_strategies='recursive'
21 default_octopus_strategies='octopus'
22 no_trivial_merge_strategies='ours subtree'
23 use_strategies=
24
25 index_merge=t
26
27 dropsave() {
28 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
29 "$GIT_DIR/MERGE_SAVE" || exit 1
30 }
31
32 savestate() {
33 # Stash away any local modifications.
34 git-diff-index -z --name-only $head |
35 cpio -0 -o >"$GIT_DIR/MERGE_SAVE"
36 }
37
38 restorestate() {
39 if test -f "$GIT_DIR/MERGE_SAVE"
40 then
41 git reset --hard $head >/dev/null
42 cpio -iuv <"$GIT_DIR/MERGE_SAVE"
43 git-update-index --refresh >/dev/null
44 fi
45 }
46
47 finish_up_to_date () {
48 case "$squash" in
49 t)
50 echo "$1 (nothing to squash)" ;;
51 '')
52 echo "$1" ;;
53 esac
54 dropsave
55 }
56
57 squash_message () {
58 echo Squashed commit of the following:
59 echo
60 git-log --no-merges ^"$head" $remote
61 }
62
63 finish () {
64 if test '' = "$2"
65 then
66 rlogm="$GIT_REFLOG_ACTION"
67 else
68 echo "$2"
69 rlogm="$GIT_REFLOG_ACTION: $2"
70 fi
71 case "$squash" in
72 t)
73 echo "Squash commit -- not updating HEAD"
74 squash_message >"$GIT_DIR/SQUASH_MSG"
75 ;;
76 '')
77 case "$merge_msg" in
78 '')
79 echo "No merge message -- not updating HEAD"
80 ;;
81 *)
82 git-update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
83 ;;
84 esac
85 ;;
86 esac
87 case "$1" in
88 '')
89 ;;
90 ?*)
91 case "$no_summary" in
92 '')
93 git-diff-tree --stat --summary -M "$head" "$1"
94 ;;
95 esac
96 ;;
97 esac
98 }
99
100 merge_name () {
101 remote="$1"
102 rh=$(git-rev-parse --verify "$remote^0" 2>/dev/null) || return
103 bh=$(git-show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
104 if test "$rh" = "$bh"
105 then
106 echo "$rh branch '$remote' of ."
107 elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
108 git-show-ref -q --verify "refs/heads/$truname" 2>/dev/null
109 then
110 echo "$rh branch '$truname' (early part) of ."
111 elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
112 then
113 sed -e 's/ not-for-merge / /' -e 1q \
114 "$GIT_DIR/FETCH_HEAD"
115 else
116 echo "$rh commit '$remote'"
117 fi
118 }
119
120 case "$#" in 0) usage ;; esac
121
122 have_message=
123 while case "$#" in 0) break ;; esac
124 do
125 case "$1" in
126 -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
127 --no-summa|--no-summar|--no-summary)
128 no_summary=t ;;
129 --sq|--squ|--squa|--squas|--squash)
130 squash=t no_commit=t ;;
131 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
132 no_commit=t ;;
133 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
134 --strateg=*|--strategy=*|\
135 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
136 case "$#,$1" in
137 *,*=*)
138 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
139 1,*)
140 usage ;;
141 *)
142 strategy="$2"
143 shift ;;
144 esac
145 case " $all_strategies " in
146 *" $strategy "*)
147 use_strategies="$use_strategies$strategy " ;;
148 *)
149 die "available strategies are: $all_strategies" ;;
150 esac
151 ;;
152 -m=*|--m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
153 merge_msg=`expr "z$1" : 'z-[^=]*=\(.*\)'`
154 have_message=t
155 ;;
156 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
157 shift
158 case "$#" in
159 1) usage ;;
160 esac
161 merge_msg="$1"
162 have_message=t
163 ;;
164 -*) usage ;;
165 *) break ;;
166 esac
167 shift
168 done
169
170 # This could be traditional "merge <msg> HEAD <commit>..." and the
171 # way we can tell it is to see if the second token is HEAD, but some
172 # people might have misused the interface and used a committish that
173 # is the same as HEAD there instead. Traditional format never would
174 # have "-m" so it is an additional safety measure to check for it.
175
176 if test -z "$have_message" &&
177 second_token=$(git-rev-parse --verify "$2^0" 2>/dev/null) &&
178 head_commit=$(git-rev-parse --verify "HEAD" 2>/dev/null) &&
179 test "$second_token" = "$head_commit"
180 then
181 merge_msg="$1"
182 shift
183 head_arg="$1"
184 shift
185 elif ! git-rev-parse --verify HEAD >/dev/null 2>&1
186 then
187 # If the merged head is a valid one there is no reason to
188 # forbid "git merge" into a branch yet to be born. We do
189 # the same for "git pull".
190 if test 1 -ne $#
191 then
192 echo >&2 "Can merge only exactly one commit into empty head"
193 exit 1
194 fi
195
196 rh=$(git rev-parse --verify "$1^0") ||
197 die "$1 - not something we can merge"
198
199 git-update-ref -m "initial pull" HEAD "$rh" "" &&
200 git-read-tree --reset -u HEAD
201 exit
202
203 else
204 # We are invoked directly as the first-class UI.
205 head_arg=HEAD
206
207 # All the rest are the commits being merged; prepare
208 # the standard merge summary message to be appended to
209 # the given message. If remote is invalid we will die
210 # later in the common codepath so we discard the error
211 # in this loop.
212 merge_name=$(for remote
213 do
214 merge_name "$remote"
215 done | git-fmt-merge-msg
216 )
217 merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
218 fi
219 head=$(git-rev-parse --verify "$head_arg"^0) || usage
220
221 # All the rest are remote heads
222 test "$#" = 0 && usage ;# we need at least one remote head.
223 set_reflog_action "merge $*"
224
225 remoteheads=
226 for remote
227 do
228 remotehead=$(git-rev-parse --verify "$remote"^0 2>/dev/null) ||
229 die "$remote - not something we can merge"
230 remoteheads="${remoteheads}$remotehead "
231 eval GITHEAD_$remotehead='"$remote"'
232 export GITHEAD_$remotehead
233 done
234 set x $remoteheads ; shift
235
236 case "$use_strategies" in
237 '')
238 case "$#" in
239 1)
240 var="`git-config --get pull.twohead`"
241 if test -n "$var"
242 then
243 use_strategies="$var"
244 else
245 use_strategies="$default_twohead_strategies"
246 fi ;;
247 *)
248 var="`git-config --get pull.octopus`"
249 if test -n "$var"
250 then
251 use_strategies="$var"
252 else
253 use_strategies="$default_octopus_strategies"
254 fi ;;
255 esac
256 ;;
257 esac
258
259 for s in $use_strategies
260 do
261 for nt in $no_trivial_merge_strategies
262 do
263 case " $s " in
264 *" $nt "*)
265 index_merge=f
266 break
267 ;;
268 esac
269 done
270 done
271
272 case "$#" in
273 1)
274 common=$(git-merge-base --all $head "$@")
275 ;;
276 *)
277 common=$(git-show-branch --merge-base $head "$@")
278 ;;
279 esac
280 echo "$head" >"$GIT_DIR/ORIG_HEAD"
281
282 case "$index_merge,$#,$common,$no_commit" in
283 f,*)
284 # We've been told not to try anything clever. Skip to real merge.
285 ;;
286 ?,*,'',*)
287 # No common ancestors found. We need a real merge.
288 ;;
289 ?,1,"$1",*)
290 # If head can reach all the merge then we are up to date.
291 # but first the most common case of merging one remote.
292 finish_up_to_date "Already up-to-date."
293 exit 0
294 ;;
295 ?,1,"$head",*)
296 # Again the most common case of merging one remote.
297 echo "Updating $(git-rev-parse --short $head)..$(git-rev-parse --short $1)"
298 git-update-index --refresh 2>/dev/null
299 msg="Fast forward"
300 if test -n "$have_message"
301 then
302 msg="$msg (no commit created; -m option ignored)"
303 fi
304 new_head=$(git-rev-parse --verify "$1^0") &&
305 git-read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
306 finish "$new_head" "$msg" || exit
307 dropsave
308 exit 0
309 ;;
310 ?,1,?*"$LF"?*,*)
311 # We are not doing octopus and not fast forward. Need a
312 # real merge.
313 ;;
314 ?,1,*,)
315 # We are not doing octopus, not fast forward, and have only
316 # one common.
317 git-update-index --refresh 2>/dev/null
318 case " $use_strategies " in
319 *' recursive '*|*' recur '*)
320 : run merge later
321 ;;
322 *)
323 # See if it is really trivial.
324 git var GIT_COMMITTER_IDENT >/dev/null || exit
325 echo "Trying really trivial in-index merge..."
326 if git-read-tree --trivial -m -u -v $common $head "$1" &&
327 result_tree=$(git-write-tree)
328 then
329 echo "Wonderful."
330 result_commit=$(
331 echo "$merge_msg" |
332 git-commit-tree $result_tree -p HEAD -p "$1"
333 ) || exit
334 finish "$result_commit" "In-index merge"
335 dropsave
336 exit 0
337 fi
338 echo "Nope."
339 esac
340 ;;
341 *)
342 # An octopus. If we can reach all the remote we are up to date.
343 up_to_date=t
344 for remote
345 do
346 common_one=$(git-merge-base --all $head $remote)
347 if test "$common_one" != "$remote"
348 then
349 up_to_date=f
350 break
351 fi
352 done
353 if test "$up_to_date" = t
354 then
355 finish_up_to_date "Already up-to-date. Yeeah!"
356 exit 0
357 fi
358 ;;
359 esac
360
361 # We are going to make a new commit.
362 git var GIT_COMMITTER_IDENT >/dev/null || exit
363
364 # At this point, we need a real merge. No matter what strategy
365 # we use, it would operate on the index, possibly affecting the
366 # working tree, and when resolved cleanly, have the desired tree
367 # in the index -- this means that the index must be in sync with
368 # the $head commit. The strategies are responsible to ensure this.
369
370 case "$use_strategies" in
371 ?*' '?*)
372 # Stash away the local changes so that we can try more than one.
373 savestate
374 single_strategy=no
375 ;;
376 *)
377 rm -f "$GIT_DIR/MERGE_SAVE"
378 single_strategy=yes
379 ;;
380 esac
381
382 result_tree= best_cnt=-1 best_strategy= wt_strategy=
383 merge_was_ok=
384 for strategy in $use_strategies
385 do
386 test "$wt_strategy" = '' || {
387 echo "Rewinding the tree to pristine..."
388 restorestate
389 }
390 case "$single_strategy" in
391 no)
392 echo "Trying merge strategy $strategy..."
393 ;;
394 esac
395
396 # Remember which strategy left the state in the working tree
397 wt_strategy=$strategy
398
399 git-merge-$strategy $common -- "$head_arg" "$@"
400 exit=$?
401 if test "$no_commit" = t && test "$exit" = 0
402 then
403 merge_was_ok=t
404 exit=1 ;# pretend it left conflicts.
405 fi
406
407 test "$exit" = 0 || {
408
409 # The backend exits with 1 when conflicts are left to be resolved,
410 # with 2 when it does not handle the given merge at all.
411
412 if test "$exit" -eq 1
413 then
414 cnt=`{
415 git-diff-files --name-only
416 git-ls-files --unmerged
417 } | wc -l`
418 if test $best_cnt -le 0 -o $cnt -le $best_cnt
419 then
420 best_strategy=$strategy
421 best_cnt=$cnt
422 fi
423 fi
424 continue
425 }
426
427 # Automerge succeeded.
428 result_tree=$(git-write-tree) && break
429 done
430
431 # If we have a resulting tree, that means the strategy module
432 # auto resolved the merge cleanly.
433 if test '' != "$result_tree"
434 then
435 parents=$(git-show-branch --independent "$head" "$@" | sed -e 's/^/-p /')
436 result_commit=$(echo "$merge_msg" | git-commit-tree $result_tree $parents) || exit
437 finish "$result_commit" "Merge made by $wt_strategy."
438 dropsave
439 exit 0
440 fi
441
442 # Pick the result from the best strategy and have the user fix it up.
443 case "$best_strategy" in
444 '')
445 restorestate
446 case "$use_strategies" in
447 ?*' '?*)
448 echo >&2 "No merge strategy handled the merge."
449 ;;
450 *)
451 echo >&2 "Merge with strategy $use_strategies failed."
452 ;;
453 esac
454 exit 2
455 ;;
456 "$wt_strategy")
457 # We already have its result in the working tree.
458 ;;
459 *)
460 echo "Rewinding the tree to pristine..."
461 restorestate
462 echo "Using the $best_strategy to prepare resolving by hand."
463 git-merge-$best_strategy $common -- "$head_arg" "$@"
464 ;;
465 esac
466
467 if test "$squash" = t
468 then
469 finish
470 else
471 for remote
472 do
473 echo $remote
474 done >"$GIT_DIR/MERGE_HEAD"
475 echo "$merge_msg" >"$GIT_DIR/MERGE_MSG"
476 fi
477
478 if test "$merge_was_ok" = t
479 then
480 echo >&2 \
481 "Automatic merge went well; stopped before committing as requested"
482 exit 0
483 else
484 {
485 echo '
486 Conflicts:
487 '
488 git ls-files --unmerged |
489 sed -e 's/^[^ ]* / /' |
490 uniq
491 } >>"$GIT_DIR/MERGE_MSG"
492 if test -d "$GIT_DIR/rr-cache"
493 then
494 git-rerere
495 fi
496 die "Automatic merge failed; fix conflicts and then commit the result."
497 fi